summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2015-05-14 11:43:54 +0100
committerPádraig Brady <P@draigBrady.com>2015-05-14 14:08:02 +0100
commit7f0f58fdd68e7ca86dd5db7effb2c7f94adc4a08 (patch)
tree6b50d29fb53c6d45bc9f43330abe6bf6b87f6c81
parent45b8fe430dced8c489cb64491b8716cffeeca8c3 (diff)
downloadcoreutils-7f0f58fdd68e7ca86dd5db7effb2c7f94adc4a08.tar.xz
tests: fix async allocation race on BTRFS
* tests/dd/sparse.sh: Sync files before checking allocations, which may be done asynchronously on NFS and BTRFS at least. Also mark this test as very expensive on remote file systems. * tests/du/2g.sh: Likewise, also use fallocate if available to efficiently allocate the large file, otherwise skip on remote file systems. * tests/tail-2/inotify-rotate-resources.sh: Use the more standard is_local_dir_() to check remoteness. * tests/cp/fiemap-empty.sh: Comment on the sync issue for this currerntly unused test. Fixes http://bugs.gnu.org/20570
-rwxr-xr-xtests/cp/fiemap-empty.sh1
-rwxr-xr-xtests/dd/sparse.sh9
-rwxr-xr-xtests/du/2g.sh26
-rwxr-xr-xtests/tail-2/inotify-rotate-resources.sh2
4 files changed, 26 insertions, 12 deletions
diff --git a/tests/cp/fiemap-empty.sh b/tests/cp/fiemap-empty.sh
index a5eaac5d7..b3b2cd72b 100755
--- a/tests/cp/fiemap-empty.sh
+++ b/tests/cp/fiemap-empty.sh
@@ -22,6 +22,7 @@ print_ver_ cp
# FIXME: enable any part of this test that is still relevant,
# or, if none are relevant (now that cp does not handle unwritten
# extents), just remove the test altogether.
+# Note also if checking allocations may need to sync first on BTRFS at least
skip_ 'disabled for now'
touch fiemap_chk
diff --git a/tests/dd/sparse.sh b/tests/dd/sparse.sh
index 4fdabad0c..626b4059e 100755
--- a/tests/dd/sparse.sh
+++ b/tests/dd/sparse.sh
@@ -17,6 +17,7 @@
. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
print_ver_ dd
+is_local_dir_ . || very_expensive_
require_sparse_support_
# Ensure basic sparse generation works
@@ -50,6 +51,9 @@ dd if=/dev/zero of=file.in bs=1M count=1 seek=1 conv=notrunc || fail=1
kb_alloc() { du -k "$1"|cut -f1; }
+# sync out data for async allocators like NFS/BTRFS
+# sync file.in || fail=1
+
# If our just-created input file appears to be too small,
# skip the remaining tests. On at least Solaris 10 with NFS,
# file.in is reported to occupy <= 1KiB for about 50 seconds
@@ -58,7 +62,10 @@ if test $(kb_alloc file.in) -gt 3000; then
# Ensure NUL blocks smaller than the block size are not made sparse.
# Here, with a 2MiB block size, dd's conv=sparse must *not* introduce a hole.
- dd if=file.in of=file.out bs=2M conv=sparse
+ dd if=file.in of=file.out bs=2M conv=sparse || fail=1
+
+ # Intermittently BTRFS returns 0 allocation for file.out unless synced
+ sync file.out || framework_failure_
test 2500 -lt $(kb_alloc file.out) || fail=1
# Note we recreate a sparse file first to avoid
diff --git a/tests/du/2g.sh b/tests/du/2g.sh
index 5f04488d6..12c2eede6 100755
--- a/tests/du/2g.sh
+++ b/tests/du/2g.sh
@@ -24,7 +24,6 @@ print_ver_ du
# Creating a 2GB file counts as 'very expensive'.
very_expensive_
-
# Get number of free kilobytes on current partition, so we can
# skip this test if there is insufficient free space.
free_kb=$(df -k --output=avail . | tail -n1)
@@ -42,15 +41,22 @@ test $min_kb -lt $free_kb ||
}
big=big
-rm -f $big
-{
- for i in $(seq 100); do
- # Note: 2147483648 == 2^31. Print floor(2^31/100) per iteration.
- printf %21474836s x || fail=1
- done
- # After the final iteration, append the remaining 48 bytes.
- printf %48s x || fail=1
-} > $big || fail=1
+
+if ! fallocate -l2G $big; then
+ rm -f $big
+ {
+ is_local_dir_ . || skip 'Not writing 2GB data to remote'
+ for i in $(seq 100); do
+ # Note: 2147483648 == 2^31. Print floor(2^31/100) per iteration.
+ printf %21474836s x || fail=1
+ done
+ # After the final iteration, append the remaining 48 bytes.
+ printf %48s x || fail=1
+ } > $big || fail=1
+fi
+
+# The allocation may be done asynchronously (BTRFS for example)
+sync $big || framework_failure_
du -k $big > out1 || fail=1
rm -f $big
diff --git a/tests/tail-2/inotify-rotate-resources.sh b/tests/tail-2/inotify-rotate-resources.sh
index c13959e22..d6629a87e 100755
--- a/tests/tail-2/inotify-rotate-resources.sh
+++ b/tests/tail-2/inotify-rotate-resources.sh
@@ -25,7 +25,7 @@ grep '^#define HAVE_INOTIFY 1' "$CONFIG_HEADER" >/dev/null \
require_strace_ 'inotify_add_watch,inotify_rm_watch'
# Quickly skip on remote file systems
-df --local . >/dev/null 2>&1 ||
+is_local_dir . >/dev/null 2>&1 ||
skip_ 'inotify not used on remote file system'
check_tail_output()